//+------------------------------------------------------------------+
//|                                            SuperTrend Adx Ea.mq5 |
//|                                  Copyright 2021, Fawad develops. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2021, Fawad develops."
#property link      "https://www.mql5.com"
#property version   "1.00"
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+





long Real_account =43121238;   //REAL ACCOUNT NO: FOR TRADING






#include<Trade\Trade.mqh>
CTrade trade;


const string indicatorName = "Examples\\supertrend";
int handle;
int handleAdx;

input string saperator_1 = " =-=-=-=-=-=-=-= SuperTrend Settings =-=-=-=-=-=-=-= ";// =-=-=-=-=-=-=-=
input double period = 1.5;// Period for Super Trend
input double multiplier = 1.5;// Multiplier for Super Trend
input string saperator_2 = " =-=-=-=-=-=-=-= Adx Settings =-=-=-=-=-=-=-= ";// =-=-=-=-=-=-=-=
input int adxPeriod = 14;// Adx Period
input int adxLevel = 25;// Adx Level

input string saperator_3 = " =-=-=-=-=-=-=-= Risk Management =-=-=-=-=-=-=-= ";// =-=-=-=-=-=-=-=
input int trailingStopDistance = 50; // Trailing Stop Distance Points From Super Trend Line
input int takeProfit = 1500; // Take Profit In Points
input int percent = 4; // Percentage Risk Available
input bool newPosition = false; // new Position allowance for pips movement
input double newPositionPips = 20; // New Position Pips Allowance Pips

input string saperator_4 = " =-=-=-=-=-=-=-= Lot Management =-=-=-=-=-=-=-= ";// =-=-=-=-=-=-=-=
input double lotSize = 0.1; // Lot size

input string saperator_5 = " =-=-=-=-=-=-=-= Session Time Management =-=-=-=-=-=-=-= ";// =-=-=-=-=-=-=-=
input int startingTime = 0; // Starting Hour
input int endingTime = 23; // Ending Hour


MqlDateTime date,date11;
ulong ticketTwo;
double takeProfiT;
int positions;
bool trading = true;
bool tradingTwo = true;
bool sellAvail = true;
bool buyAvail = true;
bool tradingAllowanceBuy = true;
bool tradingAllowanceSell = true;
bool accountPermission = true;
int OnInit()
  {
//---
   handleAdx = iADX(_Symbol,PERIOD_CURRENT,adxPeriod);
   handle = iCustom(_Symbol,PERIOD_CURRENT,indicatorName,period,multiplier,false);
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---
   
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
//---
   positions = PositionsTotal();
   double ask = NormalizeDouble(SymbolInfoDouble(_Symbol,SYMBOL_ASK),_Digits);
   double bid = NormalizeDouble(SymbolInfoDouble(_Symbol,SYMBOL_BID),_Digits);
   long CurAccount=AccountInfoInteger(ACCOUNT_LOGIN);
   double trendType[];
   double trendBull[];
   double trendBear[];
   double adx[];
   
   
     
   if(PositionsTotal()==0)
     {
         tradingAllowanceSell = true;
         tradingAllowanceBuy = true;
         buyAvail = true; 
         sellAvail = true;
              
     }

   TimeToStruct(TimeCurrent(),date);
   
   CopyBuffer(handleAdx,0,0,5,adx);
   CopyBuffer(handle,3,0,5,trendType);
   CopyBuffer(handle,2,0,7,trendBull);
   CopyBuffer(handle,2,0,7,trendBear);
   
   int candleNumber = Bars(_Symbol,PERIOD_CURRENT);
   
   if(newCandleAppeared(candleNumber))
     {
      trading = true;
     }
   
   if(CurAccount != Real_account){
      accountPermission = false;
      Alert("Please Purchase before using the Expert.");   
   }
   
   
   if(trendType[3]==0)
     {
      updateTrailingStopBuy(trendBull[6]-trailingStopDistance*_Point);
      closeSells();
      tradingAllowanceBuy = true;
      if(true)
        {
         double trendBullFlat;
         double trendBullLatest = trendBull[5];
         if((trendBull[6] == trendBullLatest && trendBull[5] == trendBullLatest && trendBull[4] == trendBullLatest && trendBull[3] == trendBullLatest && trendBull[2] == trendBullLatest && trendBull[1] == trendBullLatest))
           {
            trendBullFlat = trendBull[5];
            closeAll();
            tradingAllowanceBuy = false;
           }
          if(trendBull[4] == trendBullLatest)
           {
            tradingAllowanceBuy = false;            
           }
           
        }
      
     }
     else
     {
      updateTrailingStopSell(trendBear[6]+trailingStopDistance*_Point);
      closeBuys();
      tradingAllowanceSell = true;
      if(true)
        {
         double trendBearFlat;
         double trendBearLatest = trendBear[5];
         if((trendBear[6] == trendBearLatest && trendBear[5] == trendBearLatest && trendBear[4] == trendBearLatest && trendBear[3] == trendBearLatest && trendBear[2] == trendBearLatest && trendBear[1] == trendBearLatest))
           {
            trendBearFlat = trendBear[5];
            closeAll();
            tradingAllowanceSell = false;
           }
         if(trendBear[4]==trendBearLatest)
           {
            tradingAllowanceSell = false;            
           }
        }
     
     }
 
   
   if(date.hour>=startingTime && date.hour<=endingTime)
     {
      
      if(tradingTwo && accountPermission)
        {
         

         if(trendType[3]==0)
           {

            sellAvail = true;
            if(adx[4]>adxLevel && trading && buyAvail && tradingAllowanceBuy)
         
              {
               Alert("New Buy Order Placed Price :" + ask + "\n Take Profit is: " + (ask+takeProfit*_Point) + "\n Stop Loss is: "  + (trendBull[6]-trailingStopDistance*_Point));
               PlaySound("alert.wav");
               SendNotification("New Buy Order Placed Price :" + ask + "\n Take Profit is: " + (ask+takeProfit*_Point) + "\n Stop Loss is: "  + (trendBull[6]-trailingStopDistance*_Point));
               SendMail("New Order Sent","New Buy Order Placed Price :" + ask + "\n Take Profit is: " + (ask+takeProfit*_Point) + "\n Stop Loss is: "  + (trendBull[6]-trailingStopDistance*_Point));
               if(positions==0)
                 {
                  takeProfiT = ask+takeProfit*_Point;
                 }
               buyAvail = false;
               trading = false;
               trade.Buy(lotSize,_Symbol,ask,trendBull[6]-trailingStopDistance*_Point,takeProfiT);         
               ticketTwo = trade.ResultDeal();
              }
            
            
           }
          else
         
            {
             
             buyAvail = true;            
             
             if(adx[4]>adxLevel && trading && sellAvail && tradingAllowanceSell)
              {
               Alert("New Sell Order Placed Price :" + bid + "\n Take Profit is: " + (bid-takeProfit*_Point) + "\n Stop Loss is: "  + (trendBear[6]+trailingStopDistance*_Point));
               PlaySound("alert.wav");
               SendNotification("New Sell Order Placed Price :" + bid + "\n Take Profit is: " + (bid-takeProfit*_Point) + "\n Stop Loss is: "  + (trendBear[6]+trailingStopDistance*_Point));
               SendMail("New Order Sent","New Sell Order Placed Price :" + bid + "\n Take Profit is: " + (bid-takeProfit*_Point) + "\n Stop Loss is: "  + (trendBear[6]+trailingStopDistance*_Point));
               if(positions==0)
                 {
                  takeProfiT = bid-takeProfit*_Point;
                 }
               sellAvail = false;
               trading = false;

               trade.Sell(lotSize,_Symbol,bid,trendBear[6]+trailingStopDistance*_Point,takeProfiT);
               ticketTwo = trade.ResultDeal();   
              }
              closeBuys();
         
            }
      
        }
      

      checkBuyAvail(ticketTwo);
      checkSellAvail(ticketTwo);
      
      
         
      
     }
   
   
   if(date.day_of_week==5 && date.hour>=22)
     {
      closeAll();
     }
   
  }
//+------------------------------------------------------------------+



void closeAll(){



   int i;
   
   
   for(i=PositionsTotal()-1; i>=0; i--)
     {

      string symbol = PositionGetSymbol(i);

      if(symbol==_Symbol)
        {
         ulong ticket = PositionGetTicket(i);
         trade.PositionClose(ticket);
  
        }

  }

}

/*
void checkTradingAvail(){

  double sum = 0;
  double sumAllowed = AccountInfoDouble(ACCOUNT_EQUITY)/100*percent;
   
  
  for(int i=PositionsTotal()-1;i>=0;i--)
    {
     
     string symbol = PositionGetString(POSITION_SYMBOL);
     
     if(symbol == _Symbol)
       {
        
        sum+= PositionGetDouble(POSITION_PROFIT) + PositionGetDouble(POSITION_SWAP);
        
       }
     
     
    }
    
  if((sum*-1) > sumAllowed)
    {
     tradingTwo = false;
    }
  else
    {
     tradingTwo = true;
    }  

}

*/





void checkSellAvail(ulong ticket){

   double bid = NormalizeDouble(SymbolInfoDouble(_Symbol,SYMBOL_BID),_Digits);
   PositionSelectByTicket(ticket);

   double stopLoss = PositionGetDouble(POSITION_SL);
   double open = PositionGetDouble(POSITION_PRICE_OPEN);
   if(PositionGetInteger(POSITION_TYPE) == POSITION_TYPE_SELL)
     {
      
         if(newPosition)
           {
            if(bid <= open-newPositionPips*10*_Point)
              {
               sellAvail = true;
              }
           }
         
     }
   
}









void checkBuyAvail(ulong ticket){

   double ask = NormalizeDouble(SymbolInfoDouble(_Symbol,SYMBOL_ASK),_Digits);
   PositionSelectByTicket(ticket);

   double stopLoss = PositionGetDouble(POSITION_SL);
   double open = PositionGetDouble(POSITION_PRICE_OPEN);
   
   if(PositionGetInteger(POSITION_TYPE) == POSITION_TYPE_BUY)
     {
      
         if(newPosition)
           {
            if(ask >= open+newPositionPips*10*_Point)
              {
               buyAvail = true;
              }
           }

     }
   
}

bool newCandleAppeared(int candleNumber)
  {

   static int lastCandleNumber;

   if(candleNumber>lastCandleNumber)
     {

      lastCandleNumber = candleNumber;
      return true;
     }
   else
      return false;

  }



void closeSells(){


   int i;
   
   
   for(i=PositionsTotal()-1; i>=0; i--)
     {

      string symbol = PositionGetSymbol(i);

      if(symbol==_Symbol)
        {


         ulong ticket = PositionGetTicket(i);
         

         if(PositionGetInteger(POSITION_TYPE) == POSITION_TYPE_SELL)
           {

            trade.PositionClose(ticket);

           }
           
        }

  }


}

void closeBuys(){


   int i;
   
   
   for(i=PositionsTotal()-1; i>=0; i--)
     {

      string symbol = PositionGetSymbol(i);

      if(symbol==_Symbol)
        {


         ulong ticket = PositionGetTicket(i);
         

         if(PositionGetInteger(POSITION_TYPE) == POSITION_TYPE_BUY)
           {

            trade.PositionClose(ticket);

           }
           
        }

  }


}





void updateTrailingStopBuy(double value)
  {

   int i;
   double ask = NormalizeDouble(SymbolInfoDouble(_Symbol,SYMBOL_ASK),_Digits);
   
   for(i=PositionsTotal()-1; i>=0; i--)
     {

      string symbol = PositionGetSymbol(i);

      if(symbol==_Symbol)
        {


         ulong ticket = PositionGetTicket(i);
         double open = PositionGetDouble(POSITION_PRICE_OPEN);
         double sl = PositionGetDouble(POSITION_SL);

         if(PositionGetInteger(POSITION_TYPE) == POSITION_TYPE_BUY)
           {

            trade.PositionModify(ticket,value,PositionGetDouble(POSITION_TP));

           }
           
        }

     }
  }
  
  
  void updateTrailingStopSell(double value)
  {

   int i;
   double bid = NormalizeDouble(SymbolInfoDouble(_Symbol,SYMBOL_BID),_Digits);
   
   for(i=PositionsTotal()-1; i>=0; i--)
     {

      string symbol = PositionGetSymbol(i);

      if(symbol==_Symbol)
        {


         ulong ticket = PositionGetTicket(i);
         double open = PositionGetDouble(POSITION_PRICE_OPEN);
         double sl = PositionGetDouble(POSITION_SL);

         if(PositionGetInteger(POSITION_TYPE) == POSITION_TYPE_SELL)
           {

            trade.PositionModify(ticket,value,PositionGetDouble(POSITION_TP));

           }
           
        }

     }
  }
  
  
  
  
  
  bool newCandleAppearedTwo(int candleNumber)
  {

   static int lastCandleNumber;

   if(candleNumber>lastCandleNumber)
     {
      lastCandleNumber = candleNumber;
      return true;
     }
   else
      return false;

  }

  bool newCandleAppearedThree(int candleNumber)
  {

   static int lastCandleNumber;

   if(candleNumber>lastCandleNumber)
     {
      lastCandleNumber = candleNumber;
      return true;
     }
   else
      return false;

  }



